## tango 9.3.4%2Bdfsg1

=== cppserver/tangoaccesscontrol/CMakeLists.txt ===
#=============================================================================
#
# file :        CMakeLists.txt
#
# description : File to generate a TANGO device server using cmake.
#
# project :     TangoAccessControl
#
# $Author:  $
#
# $Revision:  $
# $Date:  $
#
#=============================================================================
#                This file is generated by POGO
#        (Program Obviously used to Generate tango Object)
#=============================================================================
#
#

cmake_minimum_required (VERSION 2.8)
set(CMAKE_SKIP_RPATH true)

# MAKE_ENV is the path to find common environment to buil project
#
set(MAKE_ENV ${TANGO_HOME})
#
# Project definitions
#
project(TangoAccessControl)

#
# optional compiler flags
#
set(CXXFLAGS_USER -g)


#
# Get global information
#
include(${MAKE_ENV}/cmake_tango.opt)

#
# Files for TangoAccessControl TANGO class
#
set(TANGOACCESSCONTROL TangoAccessControl)
set(TANGOACCESSCONTROL_INCLUDE ${CMAKE_SOURCE_DIR})
set(TANGOACCESSCONTROL_SRC ${TANGOACCESSCONTROL}.cpp ${TANGOACCESSCONTROL}Class.cpp ${TANGOACCESSCONTROL}StateMachine.cpp DbUtils.cpp)
#
# Files for AccessControl TANGO class
#
set(ACCESSCONTROL_PATH ../AbstractClasses)
set(ACCESSCONTROL AccessControl)
set(ACCESSCONTROL_INCLUDE ../AbstractClasses)
set(ACCESSCONTROL_SRC ${ACCESSCONTROL_PATH}/${ACCESSCONTROL}.cpp ${ACCESSCONTROL_PATH}/${ACCESSCONTROL}Class.cpp ${ACCESSCONTROL_PATH}/${ACCESSCONTROL}StateMachine.cpp)


#
# User additional include, link folders/libraries and source files
#
set(USER_INCL_DIR /usr/include/mysql)
set(USER_LIB_DIR /usr/lib/x86_64-linux-gnu)
set(USER_LIBS mysqlclient_r)
set(USER_SRC_FILES )

#
# Set gloabal info and include directories
#
set(ALL_CLASS_INCLUDE  ${TANGOACCESSCONTROL_INCLUDE} ${ACCESSCONTROL_INCLUDE}  ${USER_INCL_DIR})
set(SERVER_SRC ${TANGOACCESSCONTROL_SRC} ${ACCESSCONTROL_SRC}  ${USER_SRC_FILES} ClassFactory.cpp main.cpp)
include_directories(${ALL_CLASS_INCLUDE}  ${USER_INCL_DIR} ${TANGO_INCLUDES})

#
# Device Server generation
#
set(SERVER_NAME TangoAccessControl)
include(${MAKE_ENV}/cmake_common_target.opt)

=== lib/cpp/log4tango/src/CMakeLists.txt ===
set(SOURCES 
                Appender.cpp
                AppenderAttachable.cpp
                LayoutAppender.cpp
                FileAppender.cpp
                RollingFileAppender.cpp
                OstreamAppender.cpp
                Layout.cpp
                PatternLayout.cpp
                XmlLayout.cpp
                Logger.cpp
                LogSeparator.cpp
                LoggerStream.cpp
                LoggingEvent.cpp
                Level.cpp
                NDC.cpp
                Filter.cpp
                TimeStamp.cpp
                StringUtil.hh
                StringUtil.cpp
                DllMain.cpp
                DummyThreads.cpp
                MSThreads.cpp
                PThreads.cpp
                PortabilityImpl.hh
                PortabilityImpl.cpp)
if(WIN32)
    add_library(log4tango_objects_dyn OBJECT ${SOURCES})
    add_library(log4tango_objects_sta OBJECT ${SOURCES})
    target_compile_definitions(log4tango_objects_dyn PRIVATE "${dyn_defs}")
    target_compile_definitions(log4tango_objects_sta PRIVATE "${static_defs}")

    if(CMAKE_BUILD_TYPE STREQUAL "Debug")
        target_compile_options(log4tango_objects_sta PRIVATE "/MTd")
    else()
        target_compile_options(log4tango_objects_sta PRIVATE "/MT")
    endif()
else(WIN32)
    add_library(log4tango_objects OBJECT ${SOURCES})
    target_compile_options(log4tango_objects PRIVATE -fPIC)
endif(WIN32)

=== lib/cpp/log4tango/include/log4tango/threading/CMakeLists.txt ===
set(HEADER_FILES
                DummyThreads.hh
                PThreads.hh
                MSThreads.hh
                Threading.hh)

install(FILES ${HEADER_FILES}
        DESTINATION ${CMAKE_INSTALL_FULL_INCLUDEDIR}/tango/log4tango/threading)

## tango 9.3.4+dfsg1

=== cppserver/database/CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8.9)
project(DataBase)

include(configure/CMakeLists.txt)

# on change also adapt the versions in Makefile line 30ff
set(MAJOR_VERSION "5")
set(MINOR_VERSION "16")
set(PATCH_VERSION "0")
set(PROJECT_VERSION "${MAJOR_VERSION}.${MINOR_VERSION}.${PATCH_VERSION}")

set(SOURCES DataBase.cpp
            DataBaseClass.cpp
            DataBaseStateMachine.cpp
            ClassFactory.cpp
            main.cpp)

set(ADDITIONAL_SOURCES  DataBaseUtils.cpp
                        update_starter.cpp)

include_directories("." ${TANGO_PKG_INCLUDE_DIRS} ${MYSQL_INCLUDE_DIRS})
link_directories(${TANGO_PKG_LIBRARY_DIRS})

add_executable(Databaseds ${SOURCES} ${ADDITIONAL_SOURCES})
target_link_libraries(Databaseds ${TANGO_PKG_LIBRARIES} ${MYSQL_LIBRARIES} -Wl,-z,now -pie)
target_compile_options(Databaseds PUBLIC ${TANGO_PKG_CFLAGS_OTHER} -Wall -Wextra -D_FORTIFY_SOURCE=2 -O1 -fpie)

install(TARGETS Databaseds
        RUNTIME DESTINATION "${CMAKE_INSTALL_FULL_BINDIR}"
        CONFIGURATIONS ${CMAKE_BUILD_TYPE})

=== cppserver/starter/CMakeLists.txt ===
#=============================================================================
#
# file :        CMakeLists.txt
#
# description : File to generate a TANGO device server using cmake.
#
# project :     Starter
#
# $Author:  $
#
# $Revision:  $
# $Date:  $
#
#=============================================================================
#                This file is generated by POGO
#        (Program Obviously used to Generate tango Object)
#=============================================================================
#
#

cmake_minimum_required (VERSION 2.8)
set(CMAKE_SKIP_RPATH true)

# MAKE_ENV is the path to find common environment to buil project
#
set(MAKE_ENV /segfs/tango/cppserver/env)
#
# Project definitions
#
project(Starter)

#
# optional compiler flags
#
set(CXXFLAGS_USER -g)


#
# Get global information
#
include(${MAKE_ENV}/cmake_tango.opt)

#
# Files for Starter TANGO class
#
set(STARTER Starter)
set(STARTER_INCLUDE ${CMAKE_SOURCE_DIR})
set(STARTER_SRC ${STARTER}.cpp ${STARTER}Class.cpp ${STARTER}StateMachine.cpp CheckProcessUtil.cpp PingThread.cpp StarterUtil.cpp StartProcessThread.cpp)


#
# User additional include, link folders/libraries and source files
#
set(USER_INCL_DIR )
set(USER_LIB_DIR )
set(USER_LIBS )
set(USER_SRC_FILES )

#
# Set gloabal info and include directories
#
set(ALL_CLASS_INCLUDE  ${STARTER_INCLUDE}  ${USER_INCL_DIR})
set(SERVER_SRC ${STARTER_SRC}  ${USER_SRC_FILES} ClassFactory.cpp main.cpp)
include_directories(${ALL_CLASS_INCLUDE}  ${USER_INCL_DIR} ${TANGO_INCLUDES})

#
# Device Server generation
#
set(SERVER_NAME Starter)
include(${MAKE_ENV}/cmake_common_target.opt)

=== cppserver/tangotest/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.1.3)
set(CMP0048 NEW)
project(TangoTest LANGUAGES CXX
        VERSION 3.0)
include(FindPkgConfig)

pkg_search_module(TANGO_PKG REQUIRED tango)

set(CMAKE_CXX_STANDARD 11)
set(CMAKE_CXX_EXTENSIONS OFF)
set(CMAKE_STANDARD_REQUIRED YES)

set(SOURCES
        ClassFactory.cpp
        TangoTest.cpp
        TangoTestClass.cpp
        TangoTestStateMachine.cpp
        main.cpp)

set(HEADERS
        TangoTest.h
        TangoTestClass.h)

link_directories(${TANGO_PKG_LIBRARY_DIRS})

add_executable(${PROJECT_NAME} ${SOURCES} ${HEADERS})
target_include_directories(${PROJECT_NAME} PUBLIC ${CMAKE_CURRENT_SOURCE_DIR} ${TANGO_PKG_INCLUDE_DIRS})
target_compile_options(${PROJECT_NAME} PUBLIC ${TANGO_PKG_CFLAGS_OTHER})
target_link_libraries(${PROJECT_NAME} PUBLIC ${TANGO_PKG_LIBRARIES})
install(TARGETS ${PROJECT_NAME} RUNTIME DESTINATION bin)

=== doc/src/Makefile ===
# Makefile for Sphinx documentation
#

# You can set these variables from the command line.
SPHINXOPTS    =
SPHINXBUILD   = sphinx-build
PAPER         =
BUILDDIR      = build

# User-friendly check for sphinx-build
ifeq ($(shell which $(SPHINXBUILD) >/dev/null 2>&1; echo $$?), 1)
$(error The '$(SPHINXBUILD)' command was not found. Make sure you have Sphinx installed, then set the SPHINXBUILD environment variable to point to the full path of the '$(SPHINXBUILD)' executable. Alternatively you can add the directory with the executable to your PATH. If you don't have Sphinx installed, grab it from http://sphinx-doc.org/)
endif

# Internal variables.
PAPEROPT_a4     = -D latex_paper_size=a4
PAPEROPT_letter = -D latex_paper_size=letter
ALLSPHINXOPTS   = -d $(BUILDDIR)/doctrees $(PAPEROPT_$(PAPER)) $(SPHINXOPTS) source
# the i18n builder cannot share the environment and doctrees with the others
I18NSPHINXOPTS  = $(PAPEROPT_$(PAPER)) $(SPHINXOPTS) source

.PHONY: help clean html dirhtml singlehtml pickle json htmlhelp qthelp devhelp epub latex latexpdf text man changes linkcheck doctest gettext

help:
	@echo "Please use \`make <target>' where <target> is one of"
	@echo "  html       to make standalone HTML files"
	@echo "  dirhtml    to make HTML files named index.html in directories"
	@echo "  singlehtml to make a single large HTML file"
	@echo "  pickle     to make pickle files"
	@echo "  json       to make JSON files"
	@echo "  htmlhelp   to make HTML files and a HTML help project"
	@echo "  qthelp     to make HTML files and a qthelp project"
	@echo "  devhelp    to make HTML files and a Devhelp project"
	@echo "  epub       to make an epub"
	@echo "  latex      to make LaTeX files, you can set PAPER=a4 or PAPER=letter"
	@echo "  latexpdf   to make LaTeX files and run them through pdflatex"
	@echo "  latexpdfja to make LaTeX files and run them through platex/dvipdfmx"
	@echo "  text       to make text files"
	@echo "  man        to make manual pages"
	@echo "  texinfo    to make Texinfo files"
	@echo "  info       to make Texinfo files and run them through makeinfo"
	@echo "  gettext    to make PO message catalogs"
	@echo "  changes    to make an overview of all changed/added/deprecated items"
	@echo "  xml        to make Docutils-native XML files"
	@echo "  pseudoxml  to make pseudoxml-XML files for display purposes"
	@echo "  linkcheck  to check all external links for integrity"
	@echo "  doctest    to run all doctests embedded in the documentation (if enabled)"

clean:
	rm -rf $(BUILDDIR)/*

html:
	$(SPHINXBUILD) -b html $(ALLSPHINXOPTS) $(BUILDDIR)/html
	@echo
	@echo "Build finished. The HTML pages are in $(BUILDDIR)/html."

dirhtml:
	$(SPHINXBUILD) -b dirhtml $(ALLSPHINXOPTS) $(BUILDDIR)/dirhtml
	@echo
	@echo "Build finished. The HTML pages are in $(BUILDDIR)/dirhtml."

singlehtml:
	$(SPHINXBUILD) -b singlehtml $(ALLSPHINXOPTS) $(BUILDDIR)/singlehtml
	@echo
	@echo "Build finished. The HTML page is in $(BUILDDIR)/singlehtml."

pickle:
	$(SPHINXBUILD) -b pickle $(ALLSPHINXOPTS) $(BUILDDIR)/pickle
	@echo
	@echo "Build finished; now you can process the pickle files."

json:
	$(SPHINXBUILD) -b json $(ALLSPHINXOPTS) $(BUILDDIR)/json
	@echo
	@echo "Build finished; now you can process the JSON files."

htmlhelp:
	$(SPHINXBUILD) -b htmlhelp $(ALLSPHINXOPTS) $(BUILDDIR)/htmlhelp
	@echo
	@echo "Build finished; now you can run HTML Help Workshop with the" \
	      ".hhp project file in $(BUILDDIR)/htmlhelp."

qthelp:
	$(SPHINXBUILD) -b qthelp $(ALLSPHINXOPTS) $(BUILDDIR)/qthelp
	@echo
	@echo "Build finished; now you can run "qcollectiongenerator" with the" \
	      ".qhcp project file in $(BUILDDIR)/qthelp, like this:"
	@echo "# qcollectiongenerator $(BUILDDIR)/qthelp/TangoControlsDocumentation.qhcp"
	@echo "To view the help file:"
	@echo "# assistant -collectionFile $(BUILDDIR)/qthelp/TangoControlsDocumentation.qhc"

devhelp:
	$(SPHINXBUILD) -b devhelp $(ALLSPHINXOPTS) $(BUILDDIR)/devhelp
	@echo
	@echo "Build finished."
	@echo "To view the help file:"
	@echo "# mkdir -p $$HOME/.local/share/devhelp/TangoControlsDocumentation"
	@echo "# ln -s $(BUILDDIR)/devhelp $$HOME/.local/share/devhelp/TangoControlsDocumentation"
	@echo "# devhelp"

epub:
	$(SPHINXBUILD) -b epub $(ALLSPHINXOPTS) $(BUILDDIR)/epub
	@echo
	@echo "Build finished. The epub file is in $(BUILDDIR)/epub."

latex:
	$(SPHINXBUILD) -b latex $(ALLSPHINXOPTS) $(BUILDDIR)/latex
	@echo
	@echo "Build finished; the LaTeX files are in $(BUILDDIR)/latex."
	@echo "Run \`make' in that directory to run these through (pdf)latex" \
	      "(use \`make latexpdf' here to do that automatically)."

latexpdf:
	$(SPHINXBUILD) -b latex $(ALLSPHINXOPTS) $(BUILDDIR)/latex
	@echo "Running LaTeX files through pdflatex..."
	$(MAKE) -C $(BUILDDIR)/latex all-pdf
	@echo "pdflatex finished; the PDF files are in $(BUILDDIR)/latex."

latexpdfja:
	$(SPHINXBUILD) -b latex $(ALLSPHINXOPTS) $(BUILDDIR)/latex
	@echo "Running LaTeX files through platex and dvipdfmx..."
	$(MAKE) -C $(BUILDDIR)/latex all-pdf-ja
	@echo "pdflatex finished; the PDF files are in $(BUILDDIR)/latex."

text:
	$(SPHINXBUILD) -b text $(ALLSPHINXOPTS) $(BUILDDIR)/text
	@echo
	@echo "Build finished. The text files are in $(BUILDDIR)/text."

man:
	$(SPHINXBUILD) -b man $(ALLSPHINXOPTS) $(BUILDDIR)/man
	@echo
	@echo "Build finished. The manual pages are in $(BUILDDIR)/man."

texinfo:
	$(SPHINXBUILD) -b texinfo $(ALLSPHINXOPTS) $(BUILDDIR)/texinfo
	@echo
	@echo "Build finished. The Texinfo files are in $(BUILDDIR)/texinfo."
	@echo "Run \`make' in that directory to run these through makeinfo" \
	      "(use \`make info' here to do that automatically)."

info:
	$(SPHINXBUILD) -b texinfo $(ALLSPHINXOPTS) $(BUILDDIR)/texinfo
	@echo "Running Texinfo files through makeinfo..."
	make -C $(BUILDDIR)/texinfo info
	@echo "makeinfo finished; the Info files are in $(BUILDDIR)/texinfo."

gettext:
	$(SPHINXBUILD) -b gettext $(I18NSPHINXOPTS) $(BUILDDIR)/locale
	@echo
	@echo "Build finished. The message catalogs are in $(BUILDDIR)/locale."

changes:
	$(SPHINXBUILD) -b changes $(ALLSPHINXOPTS) $(BUILDDIR)/changes
	@echo
	@echo "The overview file is in $(BUILDDIR)/changes."

linkcheck:
	$(SPHINXBUILD) -b linkcheck $(ALLSPHINXOPTS) $(BUILDDIR)/linkcheck
	@echo
	@echo "Link check complete; look for any errors in the above output " \
	      "or in $(BUILDDIR)/linkcheck/output.txt."

doctest:
	$(SPHINXBUILD) -b doctest $(ALLSPHINXOPTS) $(BUILDDIR)/doctest
	@echo "Testing of doctests in the sources finished, look at the " \
	      "results in $(BUILDDIR)/doctest/output.txt."

xml:
	$(SPHINXBUILD) -b xml $(ALLSPHINXOPTS) $(BUILDDIR)/xml
	@echo
	@echo "Build finished. The XML files are in $(BUILDDIR)/xml."

pseudoxml:
	$(SPHINXBUILD) -b pseudoxml $(ALLSPHINXOPTS) $(BUILDDIR)/pseudoxml
	@echo
	@echo "Build finished. The pseudo-XML files are in $(BUILDDIR)/pseudoxml."

=== doc/src/requirements.txt ===
Sphinx>=1.6.5
# breathe>=4.6.0
sphinx_rtd_theme

=== utils/tango_admin/CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8.12)
project(tango_admin)

include(FindPkgConfig)

pkg_search_module(TANGO_PKG REQUIRED tango)

set(SOURCES
        tango_admin.cpp
        anyoption.cpp)

set(HEADERS
        anyoption.h)

link_directories(${TANGO_PKG_LIBRARY_DIRS})

add_executable(${PROJECT_NAME} ${SOURCES} ${HEADERS})
target_include_directories(${PROJECT_NAME} PUBLIC ${CMAKE_CURRENT_SOURCE_DIR} ${TANGO_PKG_INCLUDE_DIRS})
target_compile_options(${PROJECT_NAME} PUBLIC -std=c++0x ${TANGO_PKG_CFLAGS_OTHER})
target_link_libraries(${PROJECT_NAME} PUBLIC ${TANGO_PKG_LIBRARIES} ${CMAKE_DL_LIBS})

#TODO install

=== cppserver/database/configure/CMakeLists.txt ===
include(FindPkgConfig)
include(GNUInstallDirs)
include(configure/FindMySQL.cmake)

if(NOT CMAKE_BUILD_TYPE)
    message("No build type specified - default is DEBUG")
    set(CMAKE_BUILD_TYPE DEBUG)
endif()


if(NOT MYSQL_FOUND)
    message(SEND_ERROR " Can not find MySQL client library.")
endif()

pkg_search_module(TANGO_PKG REQUIRED tango)

if(NOT TANGO_DB_NAME)
    message("No Tango database name specified using -DTANGO_DB_NAME - default is tango")
    set(TANGO_DB_NAME tango)
endif()
if(NOT MYSQL)
    message("No MySQL client program specified using -DMYSQL - default is mysql")
    set(MYSQL mysql)
endif()
if(NOT MYSQL_ADMIN)
    message("No MySQL admin user name specified using -DMYSQL_ADMIN")
endif()
if(NOT MYSQL_ADMIN_PASSWD)
    message("No MySQL admin password specified using -DMYSQL_ADMIN_PASSWD")
endif()
if(NOT MYSQL_HOST)
    message("No MySQL hostname specified using -DMYSQL_HOST")
endif()

set(DB_SCRIPTS create_db.sh
               create_db.sql
               create_db_tables.sql
               rem_history.sql
               stored_proc.sql
               update_db_from_5_to_9.3.4.sql
               update_db_from_6_to_9.3.4.sql
               update_db_from_7_to_9.3.4.sql
               update_db_from_8_to_9.3.4.sql
               update_db_from_9.2.5_to_9.3.4.sql
               update_db.sh
               update_db.sql)

foreach(DB_SCRIPT_FILE ${DB_SCRIPTS})
    configure_file(${CMAKE_CURRENT_SOURCE_DIR}/${DB_SCRIPT_FILE}.in ${CMAKE_CURRENT_BINARY_DIR}/${DB_SCRIPT_FILE})
    install(FILES ${CMAKE_CURRENT_BINARY_DIR}/${DB_SCRIPT_FILE} DESTINATION "${CMAKE_INSTALL_PREFIX}/share/tango/db")
endforeach(DB_SCRIPT_FILE)

=== lib/cpp/client/CMakeLists.txt ===
set(SOURCES dbapi_class.cpp
            dbapi_server.cpp
            dbapi_datum.cpp
            dbapi_base.cpp
            dbapi_device.cpp
            dbapi_history.cpp
            dbapi_attribute.cpp
            dbapi_cache.cpp
            dbapi_serverdata.cpp
            devapi_attr.cpp
            devapi_base.cpp
            devapi_data.cpp
            devapi_datahist.cpp
            devapi_utils.cpp
            devapi_pipe.cpp
            api_util.cpp
            asynreq.cpp
            cbthread.cpp
            proxy_asyn.cpp
            proxy_asyn_cb.cpp
            attr_proxy.cpp
            group.cpp
            filedatabase.cpp
            apiexcept.cpp
            accessproxy.cpp
            lockthread.cpp
            event.cpp
            eventkeepalive.cpp
            eventqueue.cpp
            notifdeventconsumer.cpp
            zmqeventconsumer.cpp)

set(HEADERS accessproxy.h
            apiexcept.h
            cbthread.h
            dbapi.h
            devapi.h
            devasyn.h
            event.h
            eventconsumer.h
            filedatabase.h
            group.h
            lockthread.h
            Database.h
            DbDevice.h
            ApiUtil.h
            DeviceData.h
            DeviceAttribute.h
            DevicePipe.h
            Connection.h
            DeviceProxy.h
            AttributeProxy.h
            event.tpp
            devapi_attr.tpp
            devapi_utils.tpp
            api_util.tpp
            devapi_pipe.tpp)

add_subdirectory(helpers)
if(WIN32)
    add_library(client_objects_dyn OBJECT ${SOURCES})
    add_library(client_objects_sta OBJECT ${SOURCES})
    target_compile_definitions(client_objects_dyn PRIVATE "${dyn_defs}")
    target_compile_definitions(client_objects_sta PRIVATE "${static_defs}")

    if(CMAKE_BUILD_TYPE STREQUAL "Debug")
        target_compile_options(client_objects_sta PRIVATE "/MTd")
    else()
        target_compile_options(client_objects_sta PRIVATE "/MT")
    endif()
else(WIN32)
    add_library(client_objects OBJECT ${SOURCES})
    target_compile_options(client_objects PRIVATE -fPIC)
    if(CMAKE_BUILD_TYPE STREQUAL "Release")
        target_compile_definitions(client_objects PRIVATE _REENTRANT _TANGO_LIB)
    else()
        # Do not define _TANGO_LIB when compiling Tango debug library on Linux
        # in order to keep the same behaviour as in the past:
        # cout messages are not redirected to the logging system but are
        # instead displayed directly on the console
        target_compile_definitions(client_objects PRIVATE _REENTRANT)
    endif()
endif(WIN32)
install(FILES ${HEADERS} DESTINATION "${CMAKE_INSTALL_FULL_INCLUDEDIR}/tango")

=== lib/cpp/log4tango/CMakeLists.txt ===
#
# +1 : ? : +1  == new interface that does not break old one
# +1 : ? : 0   == new interface that breaks old one
#  ? : ? : 0   == no new interfaces, but breaks apps
#  ? :+1 : ?   == just some internal changes, nothing breaks but might work
#                 better
# CURRENT : REVISION : AGE
set (LOG4TANGO_PACKAGE_URL "https://github.com/tango-controls/cppTango")
set (LOG4TANGO_PACKAGE_BUGREPORT "https://github.com/tango-controls/cppTango/issues")

include(${CMAKE_CURRENT_SOURCE_DIR}/config/config.cmake)

add_subdirectory(include)
add_subdirectory(src)

if(BUILD_TESTING)
    add_subdirectory(tests)
endif()

=== lib/cpp/server/CMakeLists.txt ===
set(SOURCES attrdesc.cpp
            attrgetsetprop.cpp
            attribute.cpp
            attrsetval.cpp
            attrmanip.cpp
            basiccommand.cpp
            blackbox.cpp
            class_factory.cpp
            classattribute.cpp
            command.cpp
            coutappender.cpp
            classpipe.cpp
            dev_event.cpp
            dev_poll.cpp
            device.cpp
            device_2.cpp
            device_3.cpp
            device_4.cpp
            device_5.cpp
            deviceclass.cpp
            devicelog.cpp
            devintr.cpp
            dintrthread.cpp
            dserver.cpp
            dserverclass.cpp
            dserverlock.cpp
            dserverlog.cpp
            dserverpoll.cpp
            dserversignal.cpp
            encoded_attribute.cpp
            eventcmds.cpp
            eventsupplier.cpp
            except.cpp
            fwdattrdesc.cpp
            fwdattribute.cpp
            logcmds.cpp
            logging.cpp
            logstream.cpp
            multiattribute.cpp
            notifdeventsupplier.cpp
            pipe.cpp
            pollcmds.cpp
            pollobj.cpp
            pollring.cpp
            pollthread.cpp
            rootattreg.cpp
            seqvec.cpp
            subdev_diag.cpp
            tangoappender.cpp
            tangorollingfileappender.cpp
            templ_inst.cpp
            thsig.cpp
            utils.cpp
            utils_polling.cpp
            utils_shut.cpp
            w_attribute.cpp
            w_pipe.cpp
            zmqeventsupplier.cpp)

set(HEADERS attrdesc.h
            attribute.h
            attribute.tpp
            attrsetval.tpp
            attribute_spec.tpp
            attrmanip.h
            attrprop.h
            attrprop.tpp
            auto_tango_monitor.h
            basiccommand.h
            blackbox.h
            classattribute.h
            classpipe.h
            command.h
            pipe.h
            pipe.tpp
            coutappender.h
            coutbuf.h
            device.h
            device_2.h
            device_3.h
            device_3.tpp
            device_4.h
            device_5.h
            deviceclass.h
            devintr.h
            dintrthread.h
            dserver.h
            dserverclass.h
            dserversignal.h
            eventsupplier.h
            except.h
            fwdattrdesc.h
            fwdattribute.h
            fwdattribute.tpp
            fwdattribute_spec.tpp
            log4tango.h
            logcmds.h
            logging.h
            logstream.h
            multiattribute.h
            ntservice.h
            pipedesc.h
            pollcmds.h
            pollext.h
            pollext.tpp
            pollobj.h
            pollring.h
            pollring.tpp
            pollthread.h
            pollthread.tpp
            readers_writers_lock.h
            rootattreg.h
            seqvec.h
            tango.h
            tango_config.h
            tango_monitor.h
            tangoappender.h
            tangorollingfileappender.h
            utils.h
            utils.tpp
            utils_spec.tpp
            w32win.h
            w_attribute.h
            w_attribute.tpp
            w_attrsetval.tpp
            w_attribute_spec.tpp
            w_pipe.h
            w_pipe.tpp
            subdev_diag.h
            encoded_attribute.h
            encoded_format.h)

add_subdirectory(idl)
add_subdirectory(jpeg)
add_subdirectory(jpeg_mmx)

if(WIN32)
    set(SOURCES_WIN
        coutbuf.cpp
        ntservice.cpp
        w32win.cpp)
          
    add_library(server_objects_dyn OBJECT ${SOURCES} ${SOURCES_WIN})
    add_library(server_objects_sta OBJECT ${SOURCES} ${SOURCES_WIN})
    target_compile_definitions(server_objects_dyn PRIVATE "${dyn_defs}")
    target_compile_definitions(server_objects_sta PRIVATE "${static_defs}")

    if(CMAKE_BUILD_TYPE STREQUAL "Debug")
        target_compile_options(server_objects_sta PRIVATE "/MTd")
    else()
        target_compile_options(server_objects_sta PRIVATE "/MT")
    endif()
else(WIN32)
    add_library(server_objects OBJECT ${SOURCES})
    target_compile_options(server_objects PRIVATE -fPIC)
    if(CMAKE_BUILD_TYPE STREQUAL "Release")
        target_compile_definitions(server_objects PRIVATE _REENTRANT _TANGO_LIB)
    else()
        # Do not define _TANGO_LIB when compiling Tango debug library on Linux
        # in order to keep the same behaviour as in the past:
        # A Linux Tango Device Server using the debug tango lib will display
        # twice "Ready to accept requests" at startup
        target_compile_definitions(server_objects PRIVATE _REENTRANT)
    endif()
endif(WIN32)

configure_file(${CMAKE_CURRENT_SOURCE_DIR}/tango_const.h.in ${CMAKE_CURRENT_BINARY_DIR}/tango_const.h)

install(FILES ${HEADERS} DESTINATION "${CMAKE_INSTALL_FULL_INCLUDEDIR}/tango")
install(FILES ${CMAKE_CURRENT_BINARY_DIR}/tango_const.h DESTINATION "${CMAKE_INSTALL_FULL_INCLUDEDIR}/tango")

=== lib/cpp/client/helpers/CMakeLists.txt ===
set(HELPERS DeviceProxyHelper.h
            PogoHelper.h
            TangoExceptionsHelper.h
            Xstring.h)

install(FILES ${HELPERS} DESTINATION "${CMAKE_INSTALL_FULL_INCLUDEDIR}/tango")

=== lib/cpp/log4tango/include/CMakeLists.txt ===
add_subdirectory(log4tango)

=== debian/changelog ===
tango (9.3.4+dfsg1-2+deb12u1) bookworm; urgency=medium

  * Team upload
  * Make the property_* tables compatible with MariaDB 10.11 at install time.
    Thanks to Thomas Braun. Also update table modifications accordingly in
    dbconfig-common when upgrading from 9.3.4 (Closes: #1062979).
  * Add d/tests/starter-basic, including a test for #1062979.
  * Switch Salsa CI RELEASE variable from experimental to bookworm. Otherwise,
    Salsa CI runs the pipeline on experimental, and it has to be manually
    overriden.

 -- Santiago Ruano Rincón <santiago@freexian.com>  Wed, 04 Dec 2024 23:30:01 -0300

tango (9.3.4+dfsg1-2) unstable; urgency=medium

  [ Picca Frédéric-Emmanuel ]
  * Bug fix: "tango-starter has an unmet service dependency from some
    other service", thanks to Carlos Falcon (Closes: #994226).
  * Bump debhelper from old 12 to 13.
  * Update standards version to 4.6.0, no changes needed.

  [ Stephan Lachnit, Utkarsh Gupta ]
  * zmq.hpp now in cppzmq-dev (Closes: #1020056)

  [ Utkarsh Gupta ]
  * Revert "Bump debhelper from old 12 to 13".

 -- Utkarsh Gupta <utkarsh@debian.org>  Fri, 11 Nov 2022 23:29:16 +0530

tango (9.3.4+dfsg1-1) unstable; urgency=medium

  * New upstream version 9.3.4+dfsg1
  * Set upstream metadata fields: Bug-Database, Bug-Submit.
  * Set upstream metadata fields: Repository, Repository-Browse.

 -- Picca Frédéric-Emmanuel <picca@debian.org>  Sat, 09 Jan 2021 18:21:32 +0100

tango (9.3.4~rc7+dfsg1-1~exp1) experimental; urgency=medium

  * New upstream version 9.3.4~rc7+dfsg1
  * Closes: #949549 for real, it was a false positive.

 -- Picca Frédéric-Emmanuel <picca@debian.org>  Wed, 02 Sep 2020 14:33:11 +0200

tango (9.3.4~rc6+dfsg1-1~exp1) experimental; urgency=medium

  * New upstream version 9.3.4~rc6+dfsg1

 -- Picca Frédéric-Emmanuel <picca@debian.org>  Tue, 16 Jun 2020 10:00:29 +0200

tango (9.3.4~rc4+dfsg1-1~exp1) experimental; urgency=medium

  * New upstream version 9.3.4~rc4+dfsg1
  * Make "Files: *" paragraph the first in the copyright file.
  * d/control: Mark -doc package as Multi-Arch: foreign
  * Bump Standards-Version to 4.5.0 (nothing to do)
  * Bug fix: "Does not use hardening flags for compilation", thanks to
    Thomas Braun (Closes: #949549).
  * Bug fix: "Move tango_admin into a directory in $PATH", thanks to
    Thomas Braun (Closes: #949540).

 -- Picca Frédéric-Emmanuel <picca@debian.org>  Sat, 02 May 2020 11:40:18 +0200

tango (9.3.4~rc2+dfsg2-1~exp3) experimental; urgency=medium

  * 2nd attempt to fix the FTBFS.

 -- Picca Frédéric-Emmanuel <picca@debian.org>  Sat, 23 Nov 2019 12:20:57 +0100

tango (9.3.4~rc2+dfsg2-1~exp2) experimental; urgency=medium

  * d/rules deal with FTBFS due to the missing sphinxdoc sequence.

 -- Picca Frédéric-Emmanuel <picca@debian.org>  Sat, 23 Nov 2019 10:04:48 +0100

tango (9.3.4~rc2+dfsg2-1~exp1) experimental; urgency=medium

  [Carlos Manuel Falcon Torres]
  * Added network to Should-[Start|Stop]. (Closes: #906921)

  [Picca Frédéric-Emmanuel]
  * New upstream version 9.3.4~rc1+dfsg1
  * Bump Standards-Version to 4.4.1 (nothing to do)
  * Switched to compat level 12.
  * d/gitlab-ci.yml Added
  * d/control: Use debhelper-compat instead of debian/compat.
  * d/watch: Use https protocol.
  * d/control: Use secure URI in Homepage field.
  * d/control: Drop unnecessary dependency on dh-autoconf.
  * d/control: Removed lyx and all the latex dependencies.
  * d/control: Added python3-sphinx, python3-ipython to build
               the documentation.
  * d/rules: Removed overwrite_dh_strip which is useless now.
  * d/control: Added Rules-Requires-Root yes to the package.
  * d/control: Fixed lintian skip-systemd-native-flag-missing-pre-depends

 -- Picca Frédéric-Emmanuel <picca@debian.org>  Wed, 13 Nov 2019 21:31:59 +0100

=== debian/control ===
Source: tango
Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
Uploaders: Picca Frédéric-Emmanuel <picca@debian.org>
Section: science
Priority: optional
Build-Depends: debhelper-compat (= 12),
               default-libmysqlclient-dev,
               libcos4-dev,
               cppzmq-dev,
               omniidl,
               po-debconf
Build-Depends-Indep: doxygen,
                     python3-ipython,
                     python3-sphinx,
                     python3-sphinx-rtd-theme
Standards-Version: 4.6.0
Vcs-Browser: https://salsa.debian.org/science-team/tango
Vcs-Git: https://salsa.debian.org/science-team/tango.git
Homepage: https://www.tango-controls.org
Rules-Requires-Root: no

Package: liblog4tango5v5
Architecture: any
Multi-Arch: same
Section: libs
Depends: ${misc:Depends}, ${shlibs:Depends}
Conflicts: liblog4tango5
Replaces: liblog4tango5
Description: logging for TANGO - shared library
 Log for TANGO is a library of C++ classes for flexible logging to files,
 syslog and other destinations. It is modeled after the Log for
 C++ library (http://jakarta.apache.org/log4j/), staying as close to
 their API as is reasonable.
 .
 This package contains the files necessary for running applications that
 use the log4tango5 library.

Package: liblog4tango-dev
Architecture: any
Multi-Arch: same
Section: libdevel
Depends: liblog4tango5v5 (= ${binary:Version}), ${misc:Depends}
Conflicts: liblog4tango4-dev, liblog4tango5-dev
Description: logging for TANGO - development library
 Log for TANGO is a library of C++ classes for flexible logging to files,
 syslog and other destinations. It is modeled after the Log for
 C++ library (http://jakarta.apache.org/log4j/), staying as close to
 their API as is reasonable.
 .
 This package contains the log4tango5 development files.

Package: liblog4tango-doc
Architecture: all
Multi-Arch: foreign
Section: doc
Depends: libjs-jquery, ${misc:Depends}
Conflicts: liblog4tango5-doc
Replaces: liblog4tango5-doc
Description: logging for TANGO - documentation
 Log for TANGO is a library of C++ classes for flexible logging to files,
 syslog and other destinations. It is modeled after the Log for
 C++ library (http://jakarta.apache.org/log4j/), staying as close to
 their API as is reasonable.
 .
 This package contains the documentation of the log4tango5 library.

Package: libtango9
Architecture: any
Multi-Arch: same
Section: libs
Depends: liblog4tango5v5 (= ${binary:Version}),
         tango-common,
         ${misc:Depends},
         ${shlibs:Depends}
Description: TANGO distributed control system - shared library
 TANGO is an object-oriented distributed control system using CORBA. In
 TANGO all objects are representations of devices, which can be on the
 same computer or distributed over a network. Communication between
 devices uses CORBA and can be synchronous, asynchronous or event driven.
 .
 The object model in TANGO supports methods, attributes and properties.
 TANGO provides an API which hides all the details of network access and
 provides object browsing, discovery, and security features. Permanent
 data is stored in a MySQL/MariaDB database.
 .
 TANGO is being actively developed as a collaborative effort between the
 ESRF (www.esrf.eu), Soleil (synchrotron-soleil.fr), Alba (www.cells.es),
 and Elettra institutes (www.elettra.trieste.it).
 .
 This package contains the files necessary for running TANGO applications.

Package: libtango-dev
Architecture: any
Multi-Arch: same
Section: libdevel
Depends: libcos4-dev,
         liblog4tango-dev (= ${binary:Version}),
         libtango9 (= ${binary:Version}),
         cppzmq-dev,
         ${misc:Depends}
Conflicts: libtango7-dev, libtango8-dev
Description: TANGO distributed control system - development library
 TANGO is an object-oriented distributed control system using CORBA. In
 TANGO all objects are representations of devices, which can be on the
 same computer or distributed over a network. Communication between
 devices uses CORBA and can be synchronous, asynchronous or event driven.
 .
 The object model in TANGO supports methods, attributes and properties.
 TANGO provides an API which hides all the details of network access and
 provides object browsing, discovery, and security features. Permanent
 data is stored in a MySQL/MariaDB database.
 .
 TANGO is being actively developed as a collaborative effort between the
 ESRF (www.esrf.eu), Soleil (synchrotron-soleil.fr), Alba (www.cells.es),
 and Elettra institutes (www.elettra.trieste.it).
 .
 This package contains the tango9 development files.

Package: libtango-doc
Architecture: all
Multi-Arch: foreign
Section: doc
Depends: ${misc:Depends}, ${sphinxdoc:Depends}
Description: TANGO distributed control system - documentation
 TANGO is an object-oriented distributed control system using CORBA. In
 TANGO all objects are representations of devices, which can be on the
 same computer or distributed over a network. Communication between
 devices uses CORBA and can be synchronous, asynchronous or event driven.
 .
 The object model in TANGO supports methods, attributes and properties.
 TANGO provides an API which hides all the details of network access and
 provides object browsing, discovery, and security features. Permanent
 data is stored in a MySQL/MariaDB database.
 .
 TANGO is being actively developed as a collaborative effort between the
 ESRF (www.esrf.eu), Soleil (synchrotron-soleil.fr), Alba (www.cells.es),
 and Elettra institutes (www.elettra.trieste.it).
 .
 This package contains the documentation for the libtango9 library.

Package: libtango-tools
Architecture: any
Section: net
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: TANGO distributed control system - common executable files
 This package provides shared files for the TANGO distributed control
 system, and sets up the required infrastructure.

Package: tango-common
Architecture: all
Multi-Arch: foreign
Section: net
Depends: adduser, ${misc:Depends}
Description: TANGO distributed control system - common files
 This package provides shared files for the TANGO distributed control
 system, and sets up the required infrastructure. It is for now an
 empty package

Package: tango-db
Architecture: any
Section: net
Depends: dbconfig-mysql | dbconfig-no-thanks,
         libtango-tools,
         lsb-base,
         ${misc:Depends},
         ${shlibs:Depends}
Recommends: default-mysql-client
Pre-Depends: ${misc:Pre-Depends}
Description: TANGO distributed control system - database server
 TANGO is an object oriented distributed control system. It allows
 communication between TANGO device processes running on the same
 computer or distributed over the network. These processes can
 provide services to the control system all over the network, such as
 hardware control or data processing.
 .
 This package provides a TANGO database server using MySQL/MariaDB.

Package: tango-starter
Architecture: any
Section: net
Depends: libtango-tools, lsb-base, ${misc:Depends}, ${shlibs:Depends}
Suggests: omninotify
Pre-Depends: ${misc:Pre-Depends}
Description: TANGO distributed control system - starter server
 TANGO is an object oriented distributed control system. It allows
 communication between TANGO device processes running on the same
 computer or distributed over the network. These processes can
 provide services to the control system all over the network, such as
 hardware control or data processing.
 .
 This package provides a TANGO device control server. It can start, stop,
 or report the status of other TANGO components.

Package: tango-accesscontrol
Architecture: any
Section: net
Depends: libtango-tools,
         lsb-base,
         tango-db,
         tango-starter,
         ${misc:Depends},
         ${shlibs:Depends}
Pre-Depends: ${misc:Pre-Depends}
Description: TANGO distributed control system - accesscontrol server
 TANGO is an object oriented distributed control system. It allows
 communication between TANGO device processes running on the same
 computer or distributed over the network. These processes can
 provide services to the control system all over the network, such as
 hardware control or data processing.
 .
 This package provides a TANGO accesscontrol server. It can be used to
 manage the users and IP addresses that are permitted to access TANGO
 devices.

Package: tango-test
Architecture: any
Section: net
Depends: tango-starter, ${misc:Depends}, ${shlibs:Depends}
Description: TANGO distributed control system - test device
 TANGO is an object oriented distributed control system. It allows
 communication between TANGO device processes running on the same
 computer or distributed over the network. These processes can
 provide services to the control system all over the network, such as
 hardware control or data processing.
 .
 This package provides a TANGO device which implements all TANGO
 attribute types, and can be used for testing the installation.

=== debian/rules ===
#!/usr/bin/make -f

include /usr/share/dpkg/pkg-info.mk

export DH_VERBOSE=1
export DEB_BUILD_MAINT_OPTIONS = hardening=+all
export DEB_LDFLAGS_MAINT_STRIP = -Wl,-Bsymbolic-functions

CONFIGURE_OPTS := --with-omni=/usr --disable-static --disable-dbcreate --disable-java --with-doxygen --disable-jpegmmx

# sphinxdoc is available only when building the arch-all packages
WITH_SPHINXDOC = $(shell if [ -x /usr/bin/dh_sphinxdoc ]; then echo "--with sphinxdoc"; fi)

%:
	dh $@ $(WITH_SPHINXDOC)

sql:
	./configure $(CONFIGURE_OPTS)
	# use this target to generate the dbconfig-common upgrade script once the debian/changelog is ok
	cp cppserver/database/update_db_from_9.2.5_to_9.3.4.sql debian/dbconfig-common/data/tango-db/upgrade/mysql/$(DEB_VERSION_UPSTREAM)
	$(MAKE) distclean

override_dh_auto_configure:
	dh_auto_configure -- $(CONFIGURE_OPTS)

override_dh_auto_build-indep:
	$(MAKE) -C lib/cpp/log4tango/doc
	$(MAKE) -C doc/src/ html

override_dh_auto_install-arch:
	dh_auto_install --destdir="$(CURDIR)/debian/tmp/"
	# install dbconfig-common scripts
	install -d debian/tmp/usr/share/dbconfig-common/data/tango-db/install
	install -p -m 644 cppserver/database/create_db.sql debian/tmp/usr/share/dbconfig-common/data/tango-db/install/mysql
	install -d debian/tmp/usr/share/
	cp -r debian/dbconfig-common debian/tmp/usr/share

	# install scripts used during the configuration
	install -d debian/tmp/usr/share/tango-db
	install -p -m 644 cppserver/database/create_db_tables.sql debian/tmp/usr/share/tango-db/create_db_tables.sql
	install -p -m 644 cppserver/database/stored_proc.sql debian/tmp/usr/share/tango-db/stored_proc.sql
	install -p -m 600 cppserver/database/my.cnf debian/tmp/usr/share/tango-db/my.cnf

override_dh_auto_install-indep:
	# move the built documentation before installing
	-cp -r doc/src/build/html doc/

	$(MAKE) -C lib/cpp/log4tango/doc install DESTDIR=$(CURDIR)/debian/tmp/
	$(MAKE) -C doc install-html DESTDIR=$(CURDIR)/debian/tmp/
	$(MAKE) -C lib/idl install DESTDIR=$(CURDIR)/debian/tmp/

	# install the tango home dir
	install -d debian/tmp/var/lib/tango

override_dh_install:
	# liblog4tango5v5
	dh_install -p liblog4tango5v5 usr/lib/*/liblog4tango.so.*

	# liblog4tango-dev
	dh_install -p liblog4tango-dev usr/include/tango/log4tango
	dh_install -p liblog4tango-dev usr/lib/*/liblog4tango*.so
	dh_install -p liblog4tango-dev usr/lib/*/pkgconfig/log4tango.pc

	# liblog4tango-doc
	dh_install -p liblog4tango-doc usr/share/doc/log4tango/log4tango-*/api usr/share/doc/liblog4tango-doc/html
	dh_install -p liblog4tango-doc usr/share/man/man3

	# libtango9
	dh_install -p libtango9 usr/lib/*/libtango.so.*

	# libtango-dev
	dh_install -p libtango-dev usr/include/tango/*.*
	dh_install -p libtango-dev usr/include/tango/idl
	dh_install -p libtango-dev usr/lib/*/libtango*.so
	dh_install -p libtango-dev usr/lib/*/pkgconfig/tango.pc

	# libtango-doc
	dh_install -p libtango-doc usr/share/doc/tango/html
	dh_install -p libtango-doc usr/share/tango/idl usr/share/doc/tango

	# libtango-tools
	dh_install -p libtango-tools usr/bin/tango_admin usr/bin

	# tango-common
	dh_install -p tango-common var/lib/tango

	# tango-db
	dh_install -p tango-db usr/bin/DataBaseds usr/lib/tango
	dh_install -p tango-db usr/share/tango-db
	dh_install -p tango-db usr/share/dbconfig-common

	# tango-starter
	dh_install -p tango-starter usr/bin/Starter usr/lib/tango

	# tango-accesscontrol
	dh_install -p tango-accesscontrol usr/bin/TangoAccessControl usr/lib/tango

	# tango-test
	dh_install -p tango-test usr/bin/TangoTest usr/lib/tango

	dh_install -X.la

override_dh_installinit:
	# the tango-accesscontrol device must be started after the tango-db.
	dh_installinit -ptango-accesscontrol --update-rcd-params="defaults 25"
	# the tango-starter device must be started after the tango-db and the tango-accesscontrol.
	dh_installinit -ptango-starter --update-rcd-params="defaults 30"
	dh_installinit -a -Ntango-accesscontrol -Ntango-starter

# Aucun test nécessaire pour la documentation
override_dh_auto_test-indep:
